package gui;

import mainClasses.ExecutionManager;
import mainClasses.GASave;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;

public class SaveAdapter implements SelectionListener {
	
	private Shell shell = null;
	
	private ExecutionManager manager = null;

	public SaveAdapter(ExecutionManager manager, Shell newShell) {
		shell = newShell;
		this.manager = manager;
	}
	
	@Override
	public void widgetDefaultSelected(SelectionEvent arg0) {
	}

	@Override
	public void widgetSelected(SelectionEvent arg0) {
		FileDialog dialog = new FileDialog(shell, SWT.SAVE);
		dialog.setText("Save");
		dialog.setFilterPath(".");
		dialog.setFilterExtensions(new String [] { "*.ga" });
		String filename = dialog.open();
		if (filename != null) {
			GASave save = new GASave();
			save.save(filename, manager);
			this.manager.setFilename(filename);
		}
	}

	public void setExecutionManager(ExecutionManager manager) {
		this.manager = manager;
	}
}
