package tests;

import globalTests.CreateProgramTreeTest;
import globalTests.LoggerTest;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import mainClassesTests.GAGenerationGeneratorTest;
import mainClassesTests.GAProgramGeneratorTest;
import mainClassesTests.GAProgramTest;
import simulationTests.DisplayTest;
import simulationTests.MemoryTest;

import commandTests.ACosCommandTest;
import commandTests.ASinCommandTest;
import commandTests.ATanCommandTest;
import commandTests.AddCommandTest;
import commandTests.AndCommandTest;
import commandTests.CosCommandTest;
import commandTests.DisplayCommandTest;
import commandTests.DivCommandTest;
import commandTests.EquCommandTest;
import commandTests.ITECommandTest;
import commandTests.Key2CommandTest;
import commandTests.KeyCommandTest;
import commandTests.LetCommandTest;
import commandTests.LogCommandTest;
import commandTests.MulCommandTest;
import commandTests.NotCommandTest;
import commandTests.NumberCommandTest;
import commandTests.OrCommandTest;
import commandTests.ReadCommandTest;
import commandTests.SinCommandTest;
import commandTests.SleepCommandTest;
import commandTests.SqrCommandTest;
import commandTests.SubCommandTest;
import commandTests.SumCommandTest;
import commandTests.TanCommandTest;
import commandTests.WriteCommandTest;

public class AllTests extends TestCase {

	public static Test suite() {
		TestSuite suiteCmd = new TestSuite();
		suiteCmd.setName("CommandTests");
		suiteCmd.addTest(AddCommandTest.suite());
		suiteCmd.addTest(AndCommandTest.suite());
		suiteCmd.addTest(DisplayCommandTest.suite());
		suiteCmd.addTest(DivCommandTest.suite());
		suiteCmd.addTest(EquCommandTest.suite());
		suiteCmd.addTest(ITECommandTest.suite());
		suiteCmd.addTest(Key2CommandTest.suite());
		suiteCmd.addTest(KeyCommandTest.suite());
		suiteCmd.addTest(LetCommandTest.suite());
		suiteCmd.addTest(LogCommandTest.suite());
		suiteCmd.addTest(MulCommandTest.suite());
		suiteCmd.addTest(NotCommandTest.suite());
		suiteCmd.addTest(NumberCommandTest.suite());
		suiteCmd.addTest(OrCommandTest.suite());
		suiteCmd.addTest(ReadCommandTest.suite());
		suiteCmd.addTest(SleepCommandTest.suite());
		suiteCmd.addTest(SqrCommandTest.suite());
		suiteCmd.addTest(SubCommandTest.suite());
		suiteCmd.addTest(WriteCommandTest.suite());
		suiteCmd.addTest(SinCommandTest.suite());
		suiteCmd.addTest(SumCommandTest.suite());
		suiteCmd.addTest(CosCommandTest.suite());
		suiteCmd.addTest(TanCommandTest.suite());
		suiteCmd.addTest(ATanCommandTest.suite());
		suiteCmd.addTest(ASinCommandTest.suite());
		suiteCmd.addTest(ACosCommandTest.suite());
		
		TestSuite suite = new TestSuite();
		suite.addTest(suiteCmd);
		suite.addTest(MemoryTest.suite());
		suite.addTest(LoggerTest.suite());
		suite.addTest(CreateProgramTreeTest.suite());
		suite.addTest(DisplayTest.suite());
		suite.addTest(GAProgramGeneratorTest.suite());
		suite.addTest(GAGenerationGeneratorTest.suite());
		suite.addTest(GAProgramTest.suite());
		return suite;
	}

}
